package cn.rankin.apiweb.controller;

import cn.rankin.apiweb.assist.resolver.RequestHeader;
import cn.rankin.apiweb.entity.GlobalHeader;
import cn.rankin.apiweb.service.user.UserService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.util.HttpUtil;
import cn.rankin.data.api.app.dto.DeviceLoginDTO;
import cn.rankin.data.api.app.dto.LoginInfoDTO;
import cn.rankin.data.api.app.vo.UserInfoVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

@RestController
@RequestMapping(value = "/token")
public class LoginController {

    @Autowired
    private UserService userService;

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<UserInfoVo> login(HttpServletRequest request, @Valid @RequestBody LoginInfoDTO loginInfoDTO) {
        String ip = HttpUtil.getClientIp(request);
        loginInfoDTO.setIp(ip);
        loginInfoDTO.setTerminal(request.getHeader("terminal"));
        return userService.login(loginInfoDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<UserInfoVo> refresh(@RequestBody DeviceLoginDTO deviceLoginDTO) {
        String deviceCode = deviceLoginDTO.getDeviceCode();
        return userService.refresh(deviceCode, Boolean.TRUE);
    }

    @RequestMapping(method = RequestMethod.DELETE)
    public APIResult<Boolean> logout(@RequestHeader GlobalHeader globalHeader) {
        String userId = globalHeader.getUid();
        return userService.logout(userId);
    }
}
