package cn.rankin.cmsweb.controller.user;

import cn.rankin.cmsweb.assist.resolver.NeedUser;
import cn.rankin.cmsweb.entity.UserDetails;
import cn.rankin.cmsweb.service.user.TerminalUserService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.dto.TerminalUserDTO;
import cn.rankin.data.api.user.dto.TerminalUserSearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.data.api.user.vo.TerminalUserVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/user")
public class TerminalUserController {

    @Autowired
    private TerminalUserService terminalUserService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<TerminalUserVo>> search(@NeedUser UserDetails user, TerminalUserSearchDTO searchDTO) {
        if (!user.isPlatForm()) {
            String merchantId = user.getMerchantId();
            searchDTO.setMerchantId(merchantId);
        }

        return terminalUserService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<TerminalUserVo> create(@RequestBody TerminalUserDTO terminalUserDTO) {
        return terminalUserService.create(terminalUserDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<TerminalUserVo> update(@RequestBody TerminalUserDTO terminalUserDTO) {
        return terminalUserService.update(terminalUserDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable("id") String id) {
        return terminalUserService.delete(id);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<TerminalUserVo> getUser(@PathVariable("id") String id) {
        return terminalUserService.getUser(id);
    }
}
