package cn.rankin.data.api.resource.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name = "r_resource")
@DynamicInsert
@DynamicUpdate
public class Resource implements Serializable {

    @Id
    private String id;

    @Column
    private String code;

    @Column
    private String name;

    @Column
    //type,{0,3}， 表示{视频, 图片}
    private Integer type;


    @Column
    private String format;

    @Column
    private String quality;

    @Column
    private Long size;

    @Column
    private String path;

    @Column
    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

    @Transient
    private String url;

    @Transient
    private Resource img;

    @Transient
    private Resource audio;
}
