package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Entity
@Table(name="u_device_bind_log")
@DynamicInsert
@DynamicUpdate
public class TerminalDeviceBindLog implements Serializable {

    @Id
    private String id;

    @Column(name = "device_code")
    private String deviceCode;

    @Column(name="user_id")
    private String userId;

    private String brand;

    private String ip;

    @Column(name="model_no")
    private String modelNo;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

    private String terminal;

}
